"""Node: a class to represent a Node of a tree        
"""
class Node(object):
    def __init__(self,anc,bl=1,name=""):
        self.ancestor=anc                   # ancestor Node
        self.children=[]                    # children Nodes
        self.branch=bl                      # branch length of branch leading to actual node
        self.name=name                      # name of node, eg. taxa name
        self.depth=self.get_depth()         # depth is just number of nodes till root
        self.height=0                       # height is dependent on branch length till leaves!

    def set_child(self,child): self.children.append(child) #append child to list

    def get_leaves(self,names=True): 
        if len(self.children)==0:
            if names:return [self.name]
            else:return [self]
        l=[]
        for child in self.children:
            l+=child.get_leaves(names)
        self.leaves=l
        return l

    
